unit som;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, DBTables, DBtoSOM, Grids, DBGrids, Mask, Spin;

type
  TfrmMain = class(TForm)
    SOMap1: TSOMap;
    DBSOM1: TDBSOM;
    Query1: TQuery;
    GroupBox1: TGroupBox;
    cbFields: TComboBox;
    SOMVisualizer1: TSOMVisualizer;
    GroupBox2: TGroupBox;
    SOMVisualizer2: TSOMVisualizer;
    seNumberOfClusters: TSpinEdit;
    Label2: TLabel;
    GroupBox3: TGroupBox;
    SOMVisualizer3: TSOMVisualizer;
    GroupBox4: TGroupBox;
    SOMVisualizer4: TSOMVisualizer;
    Label1: TLabel;
    stComp: TStaticText;
    Label3: TLabel;
    stClusters: TStaticText;
    Label4: TLabel;
    stUMatrix: TStaticText;
    Label5: TLabel;
    stHitMap: TStaticText;
    GroupBox5: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    seXDim: TSpinEdit;
    seYDim: TSpinEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    edtTrainRateInit: TMaskEdit;
    edtTrainRateEnd: TMaskEdit;
    edtNeighborhoodInit: TMaskEdit;
    edtNeighborhoodEnd: TMaskEdit;
    Label12: TLabel;
    Label13: TLabel;
    seTrainEpoch: TSpinEdit;
    seEpoch: TSpinEdit;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    GroupBox6: TGroupBox;
    btnTrain: TButton;
    Label14: TLabel;
    Label15: TLabel;
    stEpoch: TStaticText;
    stCorrection: TStaticText;
    dbmain: TDatabase;
    procedure btnTrainClick(Sender: TObject);
    procedure DBSOM1AfterTrainStep(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DBSOM1AfterFiltering(Sender: TObject);
    procedure seNumberOfClustersChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbFieldsChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.btnTrainClick(Sender: TObject);
begin
  //  
  with SOMap1 do
  begin
    XDim := seXDim.Value;
    YDim := seYDim.Value;
  end;
  with DBSOM1 do
  begin
    NeighborhoodInit := StrToFloat(edtNeighborhoodInit.Text);
    NeighborhoodEnd  := StrToFloat(edtNeighborhoodEnd.Text);
    TrainRateInit    := StrToFloat(edtTrainRateInit.Text);
    TrainRateEnd     := StrToFloat(edtTrainRateEnd.Text);
    EpochCounter     := seEpoch.Value;
    TrainEpoch       := seTrainEpoch.Value;
    NumberOfClusters := seNumberOfClusters.Value;
  end;
  btnTrain.Enabled := False;
  try
    DBSOM1.Train;
    DBSOM1.Compute;
  finally
    btnTrain.Enabled := True;
  end;
end;

procedure TfrmMain.DBSOM1AfterTrainStep(Sender: TObject);
begin
  //     
  if (DBSOM1.Epoch mod 10)=0 then
  begin
    stEpoch.Caption := IntToStr(DBSOM1.Epoch);
    stCorrection.Caption := Format('%2.5f',[DBSOM1.Correction]);
    Application.ProcessMessages;
  end;
end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //   
  case Key of
    VK_LEFT  : DBSOM1.SelX := DBSOM1.SelX-1;
    VK_RIGHT : DBSOM1.SelX := DBSOM1.SelX+1;
    VK_UP    : DBSOM1.SelY := DBSOM1.SelY-1;
    VK_DOWN  : DBSOM1.SelY := DBSOM1.SelY+1;
  end;
end;

procedure TfrmMain.DBSOM1AfterFiltering(Sender: TObject);
begin
  stUMatrix.Caption  := Format('%4.5f',[SOMVisualizer3.Value]);
  stClusters.Caption := Format('%4.5f',[SOMVisualizer2.Value]);
  stComp.Caption     := Format('%4.5f',[SOMVisualizer1.Value]);
  stHitMap.Caption   := Format('%4.5f',[SOMVisualizer4.Value]);
end;

procedure TfrmMain.seNumberOfClustersChange(Sender: TObject);
begin
  DBSOM1.NumberOfClusters := seNumberOfClusters.Value;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  dbMain.Close;
  dbMain.Params.Values['Path'] := ExtractFilePath(Application.ExeName);
  dbMain.Open;
  Query1.Open;
  cbFields.Items.Assign(DBSOM1.GetAvailableVisFields);
  cbFields.ItemIndex := 0;
  DecimalSeparator := '.';
end;

procedure TfrmMain.cbFieldsChange(Sender: TObject);
begin
  SOMVisualizer1.DataField := cbFields.Items[cbFields.ItemIndex];
  SOMVisualizer1.Compute;
end;

end.
